OSC_FREQ 		EQU d'4000000'

; Macros
; Bankumschaltungen
_BANK_0 macro
	BCF STATUS,RP0
	BCF STATUS,RP1
	endm

_BANK_1 macro
	BSF STATUS,RP0
	BCF STATUS,RP1
	endm

_BANK_2 macro
	BCF STATUS,RP0
	BSF STATUS,RP1
	endm

_BANK_3 macro
	BSF STATUS,RP0
	BSF STATUS,RP1
	endm

;===========================================================================
; Makro: _DELAY_TMR1_US
; Beschreibung:
;	Das Makro unterbricht die Programmausfhrung fr die angegebene Dauer.
;	Der angegebne Wert (usek) muss in Mikrosekunden angegeben werden und
;	muss zwischen 20 und 524000 liegen. Da der Timer 1 mit einem Prescaler
;	von 1:8 verwendet wird ist die Genauigkeit der eingestellten Zeit
;	maximal 1/8 des Befehlstaktes
;===========================================================================
_DELAY_TMR1_US macro usek
	variable timer_HL=0
	variable timer_H=0
	variable timer_L=0

	if usek > d'524000'
		error "MACRO: Wert fr Makro _DELAY_TMR1_US zu gro!"
	endif
	if usek < d'20'
		error "MACRO: Wert fr Makro _DELAY_TMR1_US zu klein!"
	endif
	
	;Berechnung der Registerinhalte
	timer_HL = d'65536'-(OSC_FREQ/d'1000000'*usek/d'4'/d'8')
	;Berechnung des Highbytes
	timer_H = (timer_HL >> d'8')
	;Berechnung des Lowbytes
	;Es wird noch 1 addiert, da das Makro aus mehreren Befehlen besteht
	timer_L = (timer_HL & 0x00FF)+d'1'
	
	_BANK_1
	bcf PIE1, TMR1IE		;Interrupt von Timer 1 ausschalten
	_BANK_0
	movlw timer_H			;lade das Highbyte in Register TMR1H
	movwf TMR1H
	movlw timer_L			;lade das Lowbyte in Register TMR1L
	movwf TMR1L
	movlw b'00110001'		;schaltet Timer 1 an, Prescaler 1:8
	movwf T1CON
	btfss PIR1, TMR1IF	;Prft das berlaufflag
	goto $-d'1'
	bcf PIR1, TMR1IF		;Timer-berlauf ist aufgetreten
								;berlaufbit zurcksetzen
	endm

;===========================================================================
; Makro: _TMR2_4MS
; Beschreibung:
;	Ruft den Interrupt alle 4 ms auf
;===========================================================================
_TMR2_4MS macro
	_BANK_1
	movlw d'99'
	movwf PR2
	_BANK_0
	clrf TMR2
	movlw b'01001101'
	movwf T2CON
	_BANK_1
	bsf PIE1, TMR2IE		;Interrupt von Timer 1 einschalten
	_BANK_0

	endm